////////////////////////////////////////////////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////s           www.testbench.in           s////
////s                                      s////
////s             UVM Tutorial             s////
////s           gopi@testbenh.in           s////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////////////////////////////////////////////////
`include "uvm.svh"
 import uvm_pkg::*;

  `include "sequence_item.sv"  
  `include "consumer.sv"  
  `include "producer.sv"

  class env extends uvm_env;
    producer p;
    consumer c;
    
    function new(string name = "env");
      super.new(name);
      p = new("producer", this);
      c = new("consumer", this);
    endfunction
    
    function void connect();
      c.get_port.connect(p.get_port);
    endfunction
    
    task run();
      #1000;
       global_stop_request();
    endtask
    
  endclass
  

module test;
  env e;
  
  initial begin
    e = new();
    run_test();
  end

endmodule 
