////////////////////////////////////////////////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////s           www.testbench.in           s////
////s                                      s////
////s             UVM Tutorial             s////
////s           gopi@testbenh.in           s////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////////////////////////////////////////////////

  class producer extends uvm_component;

    uvm_blocking_get_imp#(instruction,producer) get_port;
    
    function new(string name, uvm_component p = null);
      super.new(name,p);
      get_port = new("get_port", this);
    endfunction
    
    task get(ref instruction inst);
        inst = new();
        if(inst.randomize()) begin
        `uvm_info("producer", $sformatf("sending   %s",inst.inst.name()), UVM_MEDIUM)
        end
    endtask
    
  endclass : producer

